package sitzplangenerator;

import java.awt.Component;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.Toolkit;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JFrame;
import javax.swing.JMenu;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JSpinner;
import javax.swing.JTextArea;
import javax.swing.border.TitledBorder;
import javax.swing.plaf.FontUIResource;

/**
 * @author B. A. Bartsch
 */
public class StartSPG {
    
    public static void main(String[] args) {
        JFrame f = new JFrame("2019-12-07, Sitzplan-Generator, (c) {bar|plue}@gymnasium-eickel.herne.de");
        f.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        f.setIconImage(Static.IMAGE_LOGO_32.getImage());
        f.setSize(1024, 800);
        f.setLocationRelativeTo(null);
        f.setContentPane(new ViewPanelMain());
        f.setVisible(true);
        
        set_schrift_groesse(1, new Component[] {f});
    }
    
    private static void set_schrift_groesse(double factor, Component[] c) {
        Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
        int size1 = (int) ((d.height * factor) / 80);
        int size2 = (int) ((size1 * 3) / 4);
        Static.FONT_DEFAULT = new Font(Font.SANS_SERIF, Font.PLAIN, size1);
        Static.FONT_DEFAULT_SMALLER = new Font(Font.SANS_SERIF, Font.PLAIN, size2*2);
        Static.FONT_TITLED_BORDER = new Font(Font.SERIF, Font.BOLD, size1);
        Static.FONT_TEXT_AREA = new Font(Font.MONOSPACED, Font.PLAIN, size1);
        Static.FONT_CHECK_BOX = new Font(Font.SANS_SERIF, Font.PLAIN, size1);
        set_font_recursive(c);
    }
    
    private static void set_font_recursive(Component[] comp) {
        for (int x = 0; x < comp.length; x++) {
            Component c = comp[x];

            try {
                c.setFont(Static.FONT_DEFAULT);
            } catch (Exception ex) {
                //do nothing
            }

            if (c instanceof Container) {
                set_font_recursive(((Container) c).getComponents());
            }

            if (c instanceof JCheckBox) {
                JCheckBox cb = (JCheckBox) c;
                cb.setFont(Static.FONT_CHECK_BOX);
            }

            if (c instanceof JTextArea) {
                JTextArea ta = (JTextArea) c;
                ta.setFont(Static.FONT_TEXT_AREA);
            }

            if (c instanceof JScrollPane) {
                JScrollPane scroll = (JScrollPane) c;
                if (scroll.getBorder() instanceof TitledBorder) {
                    TitledBorder tb = (TitledBorder) scroll.getBorder();
                    tb.setTitleFont(Static.FONT_TITLED_BORDER);
                }
            }

            if (c instanceof JSpinner) {
                JSpinner spinner = (JSpinner) c;
                ((JSpinner.DefaultEditor) spinner.getEditor()).getTextField().setFont(Static.FONT_DEFAULT);
            }

            if (c instanceof JPanel) {
                JPanel panel = (JPanel) c;
                if (panel.getBorder() instanceof TitledBorder) {
                    TitledBorder tb = (TitledBorder) panel.getBorder();
                    tb.setTitleFont(Static.FONT_TITLED_BORDER);
                }
            }

            if (c instanceof JMenu) {
                JMenu menu = (JMenu) c;
                menu.setFont(new FontUIResource(Static.FONT_DEFAULT));
                set_font_recursive(menu.getMenuComponents());
            }

            if (c instanceof JButton) {
                JButton jb = (JButton) c;
                String text = jb.getText();
                if (text != null) {
                    /*if () {
                        jb.setFont(new FontUIResource(Static.FONT_DEFAULT_SMALLER));
                    }*/
                }
            }

        }
    }

}
