package sitzplangenerator;

//import com.apple.eawt.Application;
import java.awt.Font;
import java.net.URL;
import java.util.LinkedList;
import javax.swing.ImageIcon;

/**
 * @author B. A. Bartsch
 */
public class Static {

    private static final String PICTURE_PATH = "/images/";

    public static final ImageIcon IMAGE_EMPTY = new ImageIcon();
    public static final ImageIcon IMAGE_OPEN;
    public static final ImageIcon IMAGE_PRINT;
    public static final ImageIcon IMAGE_SAVE;
    public static final ImageIcon IMAGE_SHUFFLE;
    public static final ImageIcon IMAGE_IMPORT;
    public static final ImageIcon IMAGE_FAVORITES;
    public static final ImageIcon IMAGE_FAVORITES_CHOOSER;
    public static final ImageIcon IMAGE_LOGO_32;

    public static final String LINE_SEPERATOR = System.getProperty("line.separator");
    public static final String ASCII_CODE_10 = "" + ((char) (10));
    public static final String STRING_OS = System.getProperty("os.name").toLowerCase();
    final static Font FONT_NUMBER = new Font(Font.DIALOG, Font.PLAIN, 10);
    final static Font FONT_NAME = new Font(Font.DIALOG, Font.PLAIN, 10);

    static Font FONT_DEFAULT;
    static Font FONT_DEFAULT_SMALLER;
    static Font FONT_TITLED_BORDER;
    static Font FONT_TEXT_AREA;
    static Font FONT_CHECK_BOX;

    static {
        IMAGE_OPEN = getImage("action_open_48.png");
        IMAGE_PRINT = getImage("action_print_48.png");
        IMAGE_SAVE = getImage("action_save_48.png");
        IMAGE_SHUFFLE = getImage("action_dice_48.png");
        IMAGE_IMPORT = getImage("action_import_48.png");
        IMAGE_FAVORITES = getImage("action_favorites_48.png");
        IMAGE_FAVORITES_CHOOSER = getImage("action_favorites_128.png");
        IMAGE_LOGO_32 = getImage("logo_32.png");
        // logo for mac
        //if (STRING_OS.contains("mac")) {
        //    try {
        //        Application application = Application.getApplication();
        //        application.setDockIconImage(IMAGE_LOGO_32.getImage());
        //    } catch (Exception ex) {
        //    }
        //}
    }

    public static ImageIcon getImage(String filename) {
        try {
            filename = PICTURE_PATH + filename;
            URL location = Static.class.getClass().getResource(filename);
            ImageIcon icon = new ImageIcon(location);
            return icon;
        } catch (Exception ex) {
            return IMAGE_EMPTY;
        }
    }

    static int countElementsWithSeperator(LinkedList<String> lines, String regex) {
        int count = 0;
        for (String line : lines) {
            count += line.split(regex).length;
        }
        return count;
    }

}
